Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 2693)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file init_3d_model.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,12 @@
 ! -----------------
 ! $Id$
+! Implementation of uv exposure model (FK)
+! Moved initialisation of diss, e, kh, km to turbulence_closure_mod (TG)
+! Added chemical emissions (FK)
+! Initialize masking arrays and number-of-grid-points arrays before initialize
+! LSM, USM and radiation module 
+! Initialization with inifor (MS)
+! 
+! 2618 2017-11-16 15:37:30Z suehring
 ! Reorder calls of init_surfaces.
 ! 
@@ -378,4 +386,9 @@
 
     USE arrays_3d
+
+#if defined( __chem )
+    USE chemistry_model_mod,                                                   &
+        ONLY:  chem_emissions
+#endif
 
     USE cloud_parameters,                                                      &
@@ -404,5 +417,5 @@
   
     USE lsf_nudging_mod,                                                       &
-        ONLY:  lsf_init, ls_forcing_surf, nudge_init 
+        ONLY:  lsf_init, ls_forcing_surf, nudge_init
 
     USE microphysics_mod,                                                      &
@@ -415,4 +428,7 @@
     USE netcdf_interface,                                                      &
         ONLY:  dots_max, dots_num
+
+    USE netcdf_data_input_mod,                                                  &
+        ONLY:  init_3d, netcdf_data_input_interpolate, netcdf_data_input_init_3d
     
     USE particle_attributes,                                                   &
@@ -425,5 +441,9 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY:  radiation_init, radiation, radiation_scheme
+        ONLY:  radiation_init, radiation, radiation_control, radiation_scheme, &
+               read_svf_on_init,                                               &
+               write_svf_on_init, radiation_calc_svf, radiation_write_svf,     &
+               radiation_interaction, radiation_interactions,                  &
+               radiation_interaction_init, radiation_read_svf
     
     USE random_function_mod 
@@ -450,6 +470,12 @@
     USE transpose_indices
 
+    USE turbulence_closure_mod,                                                &
+        ONLY:  tcm_init_arrays, tcm_init
+
     USE urban_surface_mod,                                                     &
-        ONLY:  usm_init_urban_surface
+        ONLY:  usm_init_urban_surface, usm_allocate_surface
+
+    USE uv_exposure_model_mod,                                                 &
+        ONLY:  uvem_init, uvem_init_arrays
 
     USE wind_turbine_model_mod,                                                &
@@ -522,13 +548,9 @@
 
     ALLOCATE( d(nzb+1:nzt,nys:nyn,nxl:nxr),                                    &
-              kh(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                               &
-              km(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                               &
               p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                &
               tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 
 #if defined( __nopointer )
-    ALLOCATE( e(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                &
-              e_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
-              pt(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                               &
+    ALLOCATE( pt(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                               &
               pt_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
               u(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                &
@@ -538,5 +560,4 @@
               w(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                &
               w_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
-              te_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
               tpt_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                            &
               tu_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
@@ -544,8 +565,5 @@
               tw_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #else
-    ALLOCATE( e_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
-              e_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
-              e_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
-              pt_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
+    ALLOCATE( pt_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
               pt_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
               u_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
@@ -771,5 +789,5 @@
                             + 2.0_wp * ( rho_air(nzt+1) - rho_air_zw(nzt)  )
     ENDIF
-
+!
 !-- compute the inverse density array in order to avoid expencive divisions
     drho_air    = 1.0_wp / rho_air
@@ -878,12 +896,4 @@
 
 !
-!-- 3D-array for storing the dissipation, needed for calculating the sgs
-!-- particle velocities
-    IF ( use_sgs_for_particles  .OR.  wang_kernel  .OR.  collision_turbulence )&
-    THEN
-       ALLOCATE( diss(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-    ENDIF
-
-!
 !-- 1D-array for large scale subsidence velocity
     IF ( .NOT. ALLOCATED( w_subs ) )  THEN
@@ -932,5 +942,4 @@
 !
 !-- Initial assignment of the pointers
-    e  => e_1;   e_p  => e_2;   te_m  => e_3
     IF ( .NOT. neutral )  THEN
        pt => pt_1;  pt_p => pt_2;  tpt_m => pt_3
@@ -976,5 +985,8 @@
 #endif
 !
-!-- Initialize wall arrays
+!-- Initialize arrays for turbulence closure
+    CALL tcm_init_arrays
+!
+!-- Initialize surface arrays
     CALL init_surface_arrays
 !
@@ -997,13 +1009,12 @@
 
 !
-!-- Initialize nudging if required
-    IF ( nudging )  THEN
-       CALL nudge_init
-    ENDIF
-
-!
-!-- Initialize reading of large scale forcing from external file - if required
-    IF ( large_scale_forcing )  THEN
-       CALL lsf_init
+!-- Read uv exposure input data
+    IF ( uv_exposure )  THEN
+       CALL uvem_init
+    ENDIF
+!
+!-- Allocate uv exposure arrays
+    IF ( uv_exposure )  THEN
+       CALL uvem_init_arrays
     ENDIF
 
@@ -1032,4 +1043,6 @@
     sums_wsts_bc_l     = 0.0_wp
 
+
+
 !
 !-- Initialize model variables
@@ -1037,7 +1050,117 @@
          TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
 !
-!--    First model run of a possible job queue.
-!--    Initial profiles of the variables must be computes.
-       IF ( INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  THEN
+!--    Initialization with provided input data derived from larger-scale model
+       IF ( INDEX( initializing_actions, 'inifor' ) /= 0 )  THEN
+          CALL location_message( 'initializing with INIFOR', .FALSE. )
+!
+!--       Read initial 1D profiles from NetCDF file if available. 
+!--       At the moment, only u, v, w, pt and q are provided. 
+          CALL netcdf_data_input_init_3d
+!
+!--       Please note, at the moment INIFOR assumes only an equidistant vertical
+!--       grid. In case of vertical grid stretching, input of inital data 
+!--       need to be inter- and/or extrapolated. 
+!--       Therefore, check if zu grid on file is identical to numeric zw grid. 
+!--       Please note  
+          IF ( ANY( zu(1:nzt+1) /= init_3d%zu_atmos(1:init_3d%nzu) ) )  THEN
+
+             CALL netcdf_data_input_interpolate( init_3d%u_init(nzb+1:nzt+1),  &
+                                                 zu(nzb+1:nzt+1),              &
+                                                 init_3d%zu_atmos )
+             CALL netcdf_data_input_interpolate( init_3d%v_init(nzb+1:nzt+1),  &
+                                                 zu(nzb+1:nzt+1),              &
+                                                 init_3d%zu_atmos )
+!              CALL netcdf_data_input_interpolate( init_3d%w_init(nzb+1:nzt),    &
+!                                                  zw(nzb+1:nzt),                &
+!                                                  init_3d%zw_atmos )
+             IF ( .NOT. neutral )                                              &
+                CALL netcdf_data_input_interpolate(                            &
+                                             init_3d%pt_init(nzb+1:nzt+1),     &
+                                             zu(nzb+1:nzt+1),                  &
+                                             init_3d%zu_atmos )
+             IF ( humidity )                                                   &
+                CALL netcdf_data_input_interpolate(                            &
+                                             init_3d%q_init(nzb+1:nzt+1),      &
+                                             zu(nzb+1:nzt+1),                  &
+                                             init_3d%zu_atmos )
+          ENDIF
+
+          u_init = init_3d%u_init
+          v_init = init_3d%v_init    
+          IF( .NOT. neutral )  pt_init = init_3d%pt_init
+          IF( humidity      )  q_init  = init_3d%q_init
+
+!
+!--       Please note, Inifor provides data from nzb+1 to nzt+1. 
+!--       Initialize pt and q with Neumann condition at nzb.
+          IF( .NOT. neutral )  pt_init(nzb) = pt_init(nzb+1)
+          IF( humidity      )  q_init(nzb)  = q_init(nzb+1)
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
+                u(:,j,i) = u_init(:)
+                v(:,j,i) = v_init(:)
+                IF( .NOT. neutral )  pt(:,j,i) = pt_init(:)
+                IF( humidity      )  q(:,j,i)  = q_init(:)
+             ENDDO
+          ENDDO
+!
+!--       MS: What about the geostrophic wind profiles? Actually these
+!--           are not identical to the initial wind profiles in this case. 
+!--           This need to be further revised.
+!           ug(:) = u_init(:)
+!           vg(:) = v_init(:)
+!
+!--       Set inital w to 0
+          w = 0.0_wp
+!
+!--       Initialize the remaining quantities
+          IF ( humidity )  THEN
+             IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      qc(:,j,i) = 0.0_wp
+                      nc(:,j,i) = 0.0_wp
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      qr(:,j,i) = 0.0_wp
+                      nr(:,j,i) = 0.0_wp
+                   ENDDO
+                ENDDO
+             ENDIF
+
+          ENDIF
+
+          IF ( passive_scalar )  THEN
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   s(:,j,i) = s_init
+                ENDDO
+             ENDDO
+          ENDIF
+
+          IF ( ocean )  THEN
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   sa(:,j,i) = sa_init
+                ENDDO
+             ENDDO
+          ENDIF
+
+!
+!--       Set velocity components at non-atmospheric / oceanic grid points to 
+!--       zero. 
+          u = MERGE( u, 0.0_wp, BTEST( wall_flags_0, 1 ) )
+          v = MERGE( v, 0.0_wp, BTEST( wall_flags_0, 2 ) )
+          w = MERGE( w, 0.0_wp, BTEST( wall_flags_0, 3 ) )
+
+          CALL location_message( 'finished', .TRUE. )
+!
+!--    Initialization via computed 1D-model profiles
+       ELSEIF ( INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  THEN
 
           CALL location_message( 'initializing with 1D model profiles', .FALSE. )
@@ -1050,7 +1173,4 @@
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
-                e(:,j,i)  = e1d
-                kh(:,j,i) = kh1d
-                km(:,j,i) = km1d
                 pt(:,j,i) = pt_init
                 u(:,j,i)  = u1d
@@ -1090,50 +1210,38 @@
              ENDDO   
           ENDIF
-
+!
+!--          Store initial profiles for output purposes etc.
           IF ( .NOT. constant_diffusion )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   e(:,j,i)  = e1d
+             hom(:,1,25,:) = SPREAD( l1d, 2, statistic_regions+1 )
+          ENDIF
+!
+!--       Set velocities back to zero
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
+                DO  k = nzb, nzt
+                   u(k,j,i) = MERGE( u(k,j,i), 0.0_wp,                      &
+                                     BTEST( wall_flags_0(k,j,i), 1 ) )
+                   v(k,j,i) = MERGE( v(k,j,i), 0.0_wp,                      &
+                                     BTEST( wall_flags_0(k,j,i), 2 ) )
                 ENDDO
              ENDDO
-!
-!--          Store initial profiles for output purposes etc.
-             hom(:,1,25,:) = SPREAD( l1d, 2, statistic_regions+1 )
-
-          ELSE
-             e    = 0.0_wp  ! must be set, because used in
-          ENDIF
-!
-!--       Inside buildings set velocities back to zero
-          IF ( topography /= 'flat' )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt
-                      u(k,j,i) = MERGE( u(k,j,i), 0.0_wp,                      &
-                                        BTEST( wall_flags_0(k,j,i), 1 ) )
-                      v(k,j,i) = MERGE( v(k,j,i), 0.0_wp,                      &
-                                        BTEST( wall_flags_0(k,j,i), 2 ) )
-                   ENDDO
+          ENDDO
+          
+!
+!--       WARNING: The extra boundary conditions set after running the
+!--       -------  1D model impose an error on the divergence one layer
+!--                below the topography; need to correct later 
+!--       ATTENTION: Provisional correction for Piacsek & Williams
+!--       ---------  advection scheme: keep u and v zero one layer below
+!--                  the topography.
+          IF ( ibc_uv_b == 1 )  THEN
+!
+!--          Neumann condition
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   u(nzb,j,i) = u(nzb+1,j,i)
+                   v(nzb,j,i) = v(nzb+1,j,i)
                 ENDDO
              ENDDO
-             
-!
-!--          WARNING: The extra boundary conditions set after running the
-!--          -------  1D model impose an error on the divergence one layer
-!--                   below the topography; need to correct later 
-!--          ATTENTION: Provisional correction for Piacsek & Williams
-!--          ---------  advection scheme: keep u and v zero one layer below
-!--                     the topography.
-             IF ( ibc_uv_b == 1 )  THEN
-!
-!--             Neumann condition
-                DO  i = nxl-1, nxr+1
-                   DO  j = nys-1, nyn+1
-                      u(nzb,j,i) = u(nzb+1,j,i)
-                      v(nzb,j,i) = v(nzb+1,j,i)
-                   ENDDO
-                ENDDO
-
-             ENDIF
 
           ENDIF
@@ -1225,29 +1333,4 @@
              ENDDO
           ENDIF
-          
-          IF ( constant_diffusion )  THEN
-             km   = km_constant
-             kh   = km / prandtl_number
-             e    = 0.0_wp
-          ELSEIF ( e_init > 0.0_wp )  THEN
-             DO  k = nzb+1, nzt
-                km(k,:,:) = 0.1_wp * l_grid(k) * SQRT( e_init )
-             ENDDO
-             km(nzb,:,:)   = km(nzb+1,:,:)
-             km(nzt+1,:,:) = km(nzt,:,:)
-             kh   = km / prandtl_number
-             e    = e_init
-          ELSE
-             IF ( .NOT. ocean )  THEN
-                kh   = 0.01_wp   ! there must exist an initial diffusion, because 
-                km   = 0.01_wp   ! otherwise no TKE would be produced by the
-                              ! production terms, as long as not yet
-                              ! e = (u*/cm)**2 at k=nzb+1
-             ELSE
-                kh   = 0.00001_wp
-                km   = 0.00001_wp
-             ENDIF
-             e    = 0.0_wp
-          ENDIF
 !
 !--       Compute initial temperature field and other constants used in case
@@ -1300,5 +1383,8 @@
 
 !
-!--    Store initial profiles for output purposes etc.
+!--    Store initial profiles for output purposes etc.. Please note, in case of 
+!--    initialization of u, v, w, pt, and q via output data derived from larger 
+!--    scale models, data will not be horizontally homogeneous. Actually, a mean 
+!--    profile should be calculated before.   
        hom(:,1,5,:) = SPREAD( u(:,nys,nxl), 2, statistic_regions+1 )
        hom(:,1,6,:) = SPREAD( v(:,nys,nxl), 2, statistic_regions+1 )
@@ -1308,10 +1394,9 @@
        ENDIF
        hom(:,1,7,:)  = SPREAD( pt(:,nys,nxl), 2, statistic_regions+1 )
-       hom(:,1,23,:) = SPREAD( km(:,nys,nxl), 2, statistic_regions+1 )
-       hom(:,1,24,:) = SPREAD( kh(:,nys,nxl), 2, statistic_regions+1 )
-
+
+
+!
+!--    Store initial salinity profile
        IF ( ocean )  THEN
-!
-!--       Store initial salinity profile
           hom(:,1,26,:)  = SPREAD( sa(:,nys,nxl), 2, statistic_regions+1 )
        ENDIF
@@ -1323,8 +1408,8 @@
           hom(:,1,26,:) = SPREAD(   q(:,nys,nxl), 2, statistic_regions+1 )
           hom(:,1,29,:) = SPREAD( vpt(:,nys,nxl), 2, statistic_regions+1 )
+!
+!--       Store initial profile of specific humidity and potential
+!--       temperature
           IF ( cloud_physics  .OR.  cloud_droplets ) THEN
-!
-!--          Store initial profile of specific humidity and potential
-!--          temperature
              hom(:,1,27,:) = SPREAD(  q(:,nys,nxl), 2, statistic_regions+1 )
              hom(:,1,28,:) = SPREAD( pt(:,nys,nxl), 2, statistic_regions+1 )
@@ -1332,7 +1417,7 @@
        ENDIF
 
+!
+!--    Store initial scalar profile
        IF ( passive_scalar )  THEN
-!
-!--       Store initial scalar profile
           hom(:,1,121,:) = SPREAD(  s(:,nys,nxl), 2, statistic_regions+1 )
        ENDIF
@@ -1413,6 +1498,6 @@
 !
 !--    Initialize old and new time levels.
-       te_m = 0.0_wp; tpt_m = 0.0_wp; tu_m = 0.0_wp; tv_m = 0.0_wp; tw_m = 0.0_wp
-       e_p = e; pt_p = pt; u_p = u; v_p = v; w_p = w
+       tpt_m = 0.0_wp; tu_m = 0.0_wp; tv_m = 0.0_wp; tw_m = 0.0_wp
+       pt_p = pt; u_p = u; v_p = v; w_p = w
 
        IF ( humidity  )  THEN
@@ -1506,9 +1591,6 @@
                 w(nz_w_shift:nzt+1,j,i)  = w(0:nzt+1-nz_w_shift,j,i)
 
-                e(nz_s_shift:nzt+1,j,i)  =  e(0:nzt+1-nz_s_shift,j,i)
                 p(nz_s_shift:nzt+1,j,i)  =  p(0:nzt+1-nz_s_shift,j,i)
                 pt(nz_s_shift:nzt+1,j,i) = pt(0:nzt+1-nz_s_shift,j,i)
-                km(nz_s_shift:nzt+1,j,i) = km(0:nzt+1-nz_s_shift,j,i)
-                kh(nz_s_shift:nzt+1,j,i) = kh(0:nzt+1-nz_s_shift,j,i)
              ENDDO
           ENDDO
@@ -1534,5 +1616,4 @@
           ENDIF
           mean_inflow_profiles(:,4) = hom_sum(:,4,0)       ! pt
-          mean_inflow_profiles(:,5) = hom_sum(:,8,0)       ! e
           IF ( humidity )                                                      &
              mean_inflow_profiles(:,6) = hom_sum(:,41,0)   ! q
@@ -1578,5 +1659,4 @@
 
              mean_inflow_profiles(nz_s_shift:nzt+1,4) = hom_sum(0:nzt+1-nz_s_shift,4,0)  ! pt
-             mean_inflow_profiles(nz_s_shift:nzt+1,5) = hom_sum(0:nzt+1-nz_s_shift,8,0)  ! e
 
           ENDIF
@@ -1606,5 +1686,4 @@
                    w(k,j,nxlg:-1)  = 0.0_wp
                    pt(k,j,nxlg:-1) = mean_inflow_profiles(k,4)
-                   e(k,j,nxlg:-1)  = mean_inflow_profiles(k,5)
                    IF ( humidity )                                             &
                       q(k,j,nxlg:-1)  = mean_inflow_profiles(k,6)
@@ -1663,10 +1742,10 @@
 
 !
-!--    Inside buildings set velocities and TKE back to zero
+!--    Inside buildings set velocities back to zero
        IF ( TRIM( initializing_actions ) == 'cyclic_fill' .AND.                &
             topography /= 'flat' )  THEN
 !
-!--       Inside buildings set velocities and TKE back to zero.
-!--       Other scalars (pt, q, s, km, kh, p, sa, ...) are ignored at present,
+!--       Inside buildings set velocities back to zero.
+!--       Other scalars (pt, q, s, p, sa, ...) are ignored at present,
 !--       maybe revise later.
           DO  i = nxlg, nxrg
@@ -1679,6 +1758,4 @@
                    w(k,j,i)     = MERGE( w(k,j,i), 0.0_wp,                     &
                                          BTEST( wall_flags_0(k,j,i), 3 ) )
-                   e(k,j,i)     = MERGE( e(k,j,i), 0.0_wp,                     &
-                                         BTEST( wall_flags_0(k,j,i), 0 ) )
                    tu_m(k,j,i)  = MERGE( tu_m(k,j,i), 0.0_wp,                  &
                                          BTEST( wall_flags_0(k,j,i), 1 ) )
@@ -1687,6 +1764,4 @@
                    tw_m(k,j,i)  = MERGE( tw_m(k,j,i), 0.0_wp,                  &
                                          BTEST( wall_flags_0(k,j,i), 3 ) )
-                   te_m(k,j,i)  = MERGE( te_m(k,j,i), 0.0_wp,                  &
-                                         BTEST( wall_flags_0(k,j,i), 0 ) )
                    tpt_m(k,j,i) = MERGE( tpt_m(k,j,i), 0.0_wp,                 &
                                          BTEST( wall_flags_0(k,j,i), 0 ) )
@@ -1705,5 +1780,5 @@
 !--    Initialize new time levels (only done in order to set boundary values
 !--    including ghost points)
-       e_p = e; pt_p = pt; u_p = u; v_p = v; w_p = w
+       pt_p = pt; u_p = u; v_p = v; w_p = w
        IF ( humidity )  THEN
           q_p = q
@@ -1724,5 +1799,5 @@
 !--    have to be predefined here because they are used (but multiplied with 0)
 !--    there before they are set. 
-       te_m = 0.0_wp; tpt_m = 0.0_wp; tu_m = 0.0_wp; tv_m = 0.0_wp; tw_m = 0.0_wp
+       tpt_m = 0.0_wp; tu_m = 0.0_wp; tv_m = 0.0_wp; tw_m = 0.0_wp
        IF ( humidity )  THEN
           tq_m = 0.0_wp
@@ -1751,4 +1826,8 @@
        CALL message( 'init_3d_model', 'PA0193', 1, 2, 0, 6, 0 )
     ENDIF
+
+!
+!-- Initialize TKE, Kh and Km
+    CALL tcm_init
 
 
